package Demo4;

public class Fraction implements Nombre<Fraction> {
	private int num;
	private int den;
	
	public Fraction( int num, int den ){
		this.num = num;
		this.den = den;
		
		reduit();
	}
	
	public int getNum(){
		return num;
	}
	
	public int getDen(){
		return den;
	}
	
	private void reduit(){
		int pg = pgcd( num, den );

		num /= pg;
		den /= pg;
	}


	private static int pgcd( int a, int b ){
		while( b != 0 )
		{
			int temp = a % b;

			a = b;
			b = temp;
		}

		return a;
	}
	
	public String toString(){
		return num + "/" + den;
	}
	
	@Override
	public Fraction add(Fraction x) {
		int n = x.den * num + den * x.num;

		return new Fraction( n, den * x.den );
	}

	@Override
	public Fraction sub(Fraction x) {
		int n = x.den * num - den * x.num;

		return new Fraction( n, den * x.den );
	}

	@Override
	public Fraction mul(Fraction x) {
		return new Fraction( num * x.num, den * x.den );
	}

	@Override
	public Fraction div(Fraction x) {
		return new Fraction( num * x.den, den * x.num );
	}
}
